%global uvcommit 1fcc6d66f9df74189c74d3d390f02202bb7db953
%global uvversion 2.0.0
%global llvmversion 9.0.1
%global libgit2version 0.28.2
%global unicodeversion 13.0.0
%global libwhichcommit 81e9723c0273d78493dc8c8ed570f68d9ce7e89e
%global libgit2commit b3e1a56ebb2b9291e82dc027ba9cbcfc3ead54d3

%global pkgcommit edc31a25ad441b28bbe5608696cca978af6c988a
%global statcommit cde87c8062032883165cd242f4a5c6b7943cb0b1
%global logocommit 168fb6c1164e341df360ed6ced519e1e0cb7de3a

%global __provides_exclude_from ^%{_libdir}/%{name}/.*\\.so$
%global __requires_exclude_from ^%{_libdir}/libjulia.*\\.so$
# List all bundled libraries here
# OpenBLAS is excluded because we set a symlink to libopenblasp
%global _privatelibs lib(openblas_|openblas64_|ccalltest|LLVM-.*|uv)\\.so.*
%global __provides_exclude ^(%{_privatelibs})$
%global __requires_exclude ^(%{_privatelibs})$

%global build_debug 1
# not enough memory to build debug
%ifarch %{arm} %{ix86}
%global build_debug 0
%endif

Name:           julia
Version:        1.5.3
Release:        %mkrel 1
Group:          Development/Other
Summary:        High-level, high-performance dynamic language for technical computing
# Julia itself is MIT, with a few LGPLv2+ and GPLv2+ files
# libuv is MIT
License:        MIT and LGPLv2+ and GPLv2+
URL:            http://julialang.org/
Source0:        https://github.com/JuliaLang/julia/releases/download/v%{version}/julia-%{version}.tar.gz
# Julia currently uses a custom version of libuv, patches are not yet upstream
Source1:        https://api.github.com/repos/JuliaLang/libuv/tarball/%{uvcommit}#/libuv-%{uvcommit}.tar.gz
Source2:        https://github.com/llvm/llvm-project/releases/download/llvmorg-%{llvmversion}/llvm-%{llvmversion}.src.tar.xz
Source3:        https://api.github.com/repos/vtjnash/libwhich/tarball/%{libwhichcommit}#/libwhich-%{libwhichcommit}.tar.gz
Source4:        https://api.github.com/repos/JuliaLang/Pkg.jl/tarball/%{pkgcommit}#/Pkg-%{pkgcommit}.tar.gz
Source5:        https://api.github.com/repos/libgit2/libgit2/tarball/%{libgit2commit}#/libgit2-%{libgit2commit}.tar.gz
Source6:        https://curl.haxx.se/ca/cacert-2020-07-22.pem
Source7:        https://api.github.com/repos/JuliaLang/Statistics.jl/tarball/%{statcommit}#/Statistics-%{statcommit}.tar.gz
Source8:         http://www.unicode.org/Public/%{unicodeversion}/ucd/UnicodeData.txt#/UnicodeData-%{unicodeversion}.txt
Source9:         doc-deps.tar.gz
Source10: https://raw.githubusercontent.com/JuliaLang/julia-logo-graphics/%{logocommit}/images/julia-logo-color.svg

Patch0:         julia_unwind_version.patch
Patch1:         llvm-julia-installdirs-64.patch
# remove pipe so that memory does not run out on i586
# pipe is added by optflags in 64-bit
Patch2:         make-inc-nopipe.patch
Provides:       bundled(libuv) = %{uvversion}
Provides:       bundled(llvm) = %{llvmversion}
Provides:       bundled(libgit2) = %{libgit2version}
BuildRequires:  desktop-file-utils
BuildRequires:  dsfmt-devel
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gmp-devel >= 5.0
# Needed for libgit2 test
BuildRequires:  hostname
BuildRequires:  imagemagick
BuildRequires:  libatomic
BuildRequires:  pkgconfig(libunwind)
BuildRequires:  pkgconfig(blas)
BuildRequires:  openlibm-devel >= 0.4
# Needed for libgit2 test
BuildRequires:  openssl
BuildRequires:  mbedtls-devel
BuildRequires:  libssh2-devel
BuildRequires:  http-parser-devel
BuildRequires:  openssl-devel
BuildRequires:  libcurl-devel
BuildRequires:  curl
BuildRequires:  pcre2-devel
BuildRequires:  cmake
BuildRequires:  mpfr-devel >= 4
BuildRequires:  perl
BuildRequires:  suitesparse-devel >= 4.1
BuildRequires:  utf8proc-devel >= 2.1
BuildRequires:  zlib-devel
BuildRequires:  p7zip
BuildRequires:  python2
Requires:       julia-common = %{version}-%{release}
Requires:       p7zip
Requires:       dSFMT
# https://bugzilla.redhat.com/show_bug.cgi?id=1158026
# https://github.com/JuliaLang/julia/issues/30087
ExcludeArch:    s390x ppc64le %{arm} aarch64

%description
Julia is a high-level, high-performance dynamic programming language
for technical computing, with syntax that is familiar to users of
other technical computing environments. It provides a sophisticated
compiler, distributed parallel execution, numerical accuracy, and an
extensive mathematical function library. The library, largely written
in Julia itself, also integrates mature, best-of-breed C and Fortran
libraries for linear algebra, random number generation, signal processing,
and string processing.

This package only contains the essential parts of the Julia environment:
the julia executable and the standard library.

%package common
Summary:        Julia architecture-independent files
BuildArch:      noarch

%description common
Contains architecture-independent files required to run Julia.

%package doc
Summary:        Julia documentation and code examples
BuildArch:      noarch

%description doc
Contains the Julia manual, the reference documentation of the standard library
and code examples.

%package devel
Summary:        Julia development, debugging and testing files
Requires:       julia = %{version}-%{release}

%description devel
Contains library symbolic links and header files for developing applications
linking to the Julia library, in particular embedding it, as well as
tests and a debugging version of Julia. This package is normally not
needed when programming in the Julia language, but rather for embedding
Julia into external programs or debugging Julia itself.

%prep
%setup -q

%patch0 -p1

%if 0%{?__isa_bits} == 64
    patch -p1 < %PATCH1
%endif
%patch2 -p1

mkdir -p deps/srccache stdlib/srccache

pushd deps/srccache
    # Julia downloads tarballs for external dependencies even when the folder is present:
    # we need to copy the tarball and let the build process unpack it
    # https://github.com/JuliaLang/julia/pull/10280
    cp -p %SOURCE1 .
    cp -p %SOURCE2 .
    cp -p %SOURCE3 .
    cp -p %SOURCE5 .	
    cp -p %SOURCE6 .
    cp -p %SOURCE8 .
popd

pushd stdlib/srccache
    cp -p %SOURCE4 .
    cp -p %SOURCE7 .
popd

cp -p %SOURCE10 contrib/julia.svg

mkdir -p doc/deps
tar -C doc/deps -xzf %SOURCE9

# Required so that the image is not optimized for the build CPU
# (i386 does not work yet: https://github.com/JuliaLang/julia/issues/7185)
# Without specifying MARCH, the Julia system image would only work on native CPU
# CPU targets reflect those used upstream at
# https://github.com/JuliaCI/julia-buildbot/blob/master/master/inventory.py
%ifarch %{ix86}
%global march MARCH=pentium4
%global cpu_target JULIA_CPU_TARGET="pentium4;sandybridge,-xsaveopt,clone_all"
%endif
%ifarch x86_64
%global march MARCH=x86-64
%global cpu_target JULIA_CPU_TARGET="generic;sandybridge,-xsaveopt,clone_all;haswell,-rdrnd,base(1)"
%endif
%ifarch %{arm}
# gcc and LLVM do not support the same targets
%global march MARCH=$(echo %optflags | grep -Po 'march=\\K[^ ]*')
%global cpu_target JULIA_CPU_TARGET="generic"
%endif
%ifarch armv7hl
%global march MARCH=$(echo %optflags | grep -Po 'march=\\K[^ ]*')
%global cpu_target JULIA_CPU_TARGET="armv7-a;armv7-a,neon;armv7-a,neon,vfp4"
%endif
%ifarch aarch64
%global march MARCH=armv8-a
%global cpu_target JULIA_CPU_TARGET="generic"
%endif
%ifarch ppc64le
%global march %{nil}
%global cpu_target JULIA_CPU_TARGET="pwr8"
%endif

%global blas LIBBLAS="-lcblas -lblas" LIBBLASNAME=libcblas LIBLAPACK=-llapack LIBLAPACKNAME=liblapack

%global suitesparse_lib SUITESPARSE_LIB="-lumfpack -lcholmod -lamd -lcamd -lcolamd -lspqr"

%global cmake CMAKE=cmake

# About build, build_libdir and build_bindir, see https://github.com/JuliaLang/julia/issues/5063#issuecomment-32628111
%global julia_builddir %{_builddir}/%{name}/build

%global commonopts USE_SYSTEM_LLVM=0 USE_SYSTEM_LIBUNWIND=1 USE_SYSTEM_PCRE=1 USE_SYSTEM_BLAS=1 USE_SYSTEM_LAPACK=1 USE_SYSTEM_GMP=1 USE_SYSTEM_MPFR=1 USE_SYSTEM_SUITESPARSE=1 USE_SYSTEM_DSFMT=1 USE_SYSTEM_LIBUV=0 USE_SYSTEM_UTF8PROC=1 USE_SYSTEM_LIBGIT2=0 USE_SYSTEM_LIBSSH2=1 USE_SYSTEM_MBEDTLS=1 USE_SYSTEM_CURL=1 USE_SYSTEM_PATCHELF=1 USE_SYSTEM_LIBM=0 USE_SYSTEM_OPENLIBM=1 USE_BINARYBUILDER=0 USE_SYSTEM_ZLIB=1 USE_SYSTEM_P7ZIP=1 USE_NSEC=0 BUNDLE_DEBUG_LIBS=%{build_debug} JULIA_SPLITDEBUG=1 TAGGED_RELEASE_BANNER="Mageia %{mageia} build" VERBOSE=1 %{march} %{cpu_target} %{blas} %{suitesparse_lib} prefix=%{_prefix} bindir=%{_bindir} libdir=%{_libdir} libexecdir=%{_libexecdir} datarootdir=%{_datarootdir} includedir=%{_includedir} sysconfdir=%{_sysconfdir} build_prefix=%{julia_builddir}%{_prefix} build_bindir=%{julia_builddir}%{_bindir} build_libdir=%{julia_builddir}%{_libdir} build_private_libdir=%{julia_builddir}%{_libdir}/julia build_libexecdir=%{julia_builddir}%{_libexecdir} build_datarootdir=%{julia_builddir}%{_datarootdir} build_includedir=%{julia_builddir}%{_includedir} build_sysconfdir=%{julia_builddir}%{_sysconfdir} JULIA_CPU_THREADS=$(echo %{?_smp_mflags} | sed s/-j//)

%build
# Temporary workaround for https://github.com/JuliaLang/julia/issues/27118
%global optflags %(echo %{optflags} | sed 's/-Wp,-D_GLIBCXX_ASSERTIONS //')

# Decrease debuginfo verbosity to reduce memory consumption during final library linking
%ifarch %{arm} %{ix86}
%global optflags %(echo %{optflags} | sed 's/-g /-g1 /')
%global optflags %(echo %{optflags} | sed 's/-pipe / /g')
%endif

%ifarch %{ix86}
# Need to repeat -march here to override i686 from optflags
%global buildflags CFLAGS="%optflags -march=pentium4" CXXFLAGS="%optflags -march=pentium4"
%else
%global buildflags CFLAGS="%optflags" CXXFLAGS="%optflags"
%endif

# If debug is not built here, it is built during make install
make %{?_smp_mflags} %{buildflags} %{commonopts} release
%if 0%{?build_debug}
make %{?_smp_mflags} %{buildflags} %{commonopts} debug
%endif

%check
%ifarch ppc64le %{arm} aarch64
sed -i 's/\"numbers\",//' test/choosetests.jl
sed -i 's/\"ccall\",//' test/choosetests.jl
sed -i 's/\"vecelement\", //' test/choosetests.jl
sed -i 's/\"stress\",//' test/choosetests.jl
sed -i 's/\"errorshow\",//' test/choosetests.jl
sed -i 's/\"threads\",//' test/choosetests.jl
%endif
%ifarch %{arm}
# https://github.com/JuliaLang/julia/issues/29447
sed -i 's/readdir(STDLIB_DIR)/setdiff(readdir(STDLIB_DIR), ["Distributed"])/g' test/choosetests.jl
%endif
%ifarch ppc64le
# LinearAlgebra/lapack is the problematic test
sed -i 's/readdir(STDLIB_DIR)/setdiff(readdir(STDLIB_DIR), ["LibGit2", "LinearAlgebra"])/g' test/choosetests.jl
sed -i 's/\"cmdlineargs\", //' test/choosetests.jl
%endif

#make %{commonopts} test

%install
make %{commonopts} DESTDIR=%{buildroot} install
cp -p CONTRIBUTING.md LICENSE.md NEWS.md README.md %{buildroot}%{_docdir}/julia/

%if 0%{?build_debug}
pushd %{buildroot}%{_prefix}/share/man/man1/
    ln -s julia.1.gz julia-debug.1.gz
popd
%endif

pushd %{buildroot}%{_libdir}/julia
    # Some Julia packages rely on being able to use libjulia, but we only
    # ship %%{_libdir}/libjulia.so in the -devel package
    ln -s ../libjulia.so.1 libjulia.so
    # Raise an error in case of failure
    realpath -e libjulia.so
popd

# Install .desktop file and icons
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/scalable/apps/
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/16x16/apps/
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/24x24/apps/
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/32x32/apps/
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/48x48/apps/
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/256x256/apps/
cp -p contrib/julia.svg %{buildroot}%{_datarootdir}/icons/hicolor/scalable/apps/%{name}.svg
convert -scale 16x16 -extent 16x16 -gravity center -background transparent \
    contrib/julia.svg %{buildroot}%{_datarootdir}/icons/hicolor/16x16/apps/%{name}.png
convert -scale 24x24 -extent 24x24 -gravity center -background transparent \
    contrib/julia.svg %{buildroot}%{_datarootdir}/icons/hicolor/24x24/apps/%{name}.png
convert -scale 32x32 -extent 32x32 -gravity center -background transparent \
    contrib/julia.svg %{buildroot}%{_datarootdir}/icons/hicolor/32x32/apps/%{name}.png
convert -scale 48x48 -extent 48x48 -gravity center -background transparent \
    contrib/julia.svg %{buildroot}%{_datarootdir}/icons/hicolor/48x48/apps/%{name}.png
convert -scale 256x256 -extent 256x256 -gravity center -background transparent \
    contrib/julia.svg %{buildroot}%{_datarootdir}/icons/hicolor/256x256/apps/%{name}.png
desktop-file-validate %{buildroot}%{_datarootdir}/applications/%{name}.desktop
desktop-file-validate %{buildroot}%{_datarootdir}/applications/%{name}.desktop

rm -f %{buildroot}%{_datarootdir}/icons/hicolor/icon-theme.cache



%files
%dir %{_docdir}/julia/
%{_docdir}/julia/LICENSE.md
%doc %{_docdir}/julia/CONTRIBUTING.md
%doc %{_docdir}/julia/NEWS.md
%doc %{_docdir}/julia/README.md
%{_bindir}/julia
%{_libdir}/julia/
%exclude %{_libdir}/julia/*debug*
%{_libdir}/libjulia.so.*
%{_mandir}/man1/julia.1*
%{_datarootdir}/appdata/julia.appdata.xml
%{_datarootdir}/applications/%{name}.desktop
%{_datarootdir}/icons/hicolor/scalable/apps/%{name}.svg
%{_datarootdir}/icons/hicolor/16x16/apps/%{name}.png
%{_datarootdir}/icons/hicolor/24x24/apps/%{name}.png
%{_datarootdir}/icons/hicolor/32x32/apps/%{name}.png
%{_datarootdir}/icons/hicolor/48x48/apps/%{name}.png
%{_datarootdir}/icons/hicolor/256x256/apps/%{name}.png

%files common
%dir %{_datarootdir}/julia/
%{_datarootdir}/julia/*.jl
%{_datarootdir}/julia/base/
%{_datarootdir}/julia/stdlib/
%{_datarootdir}/julia/base.cache
%{_datarootdir}/julia/*.pem
%dir %{_sysconfdir}/julia/
%config(noreplace) %{_sysconfdir}/julia/startup.jl

%files doc
%doc %{_docdir}/julia/

%files devel
%{_libdir}/libjulia.so
%if 0%{?build_debug}
%{_bindir}/julia-debug
%{_libdir}/libjulia-debug.so*
%{_libdir}/julia/libccalltest.so.debug
%{_libdir}/julia/sys-debug.so
%endif
%{_includedir}/julia/
%{_datarootdir}/julia/test/

%post
/sbin/ldconfig
/bin/touch --no-create %{_datarootdir}/icons/hicolor &>/dev/null || :
exit 0


%changelog
* Fri Dec 25 2020 joequant <joequant> 1.5.3-1.mga8
+ Revision: 1663650
- update deps
- update to 1.5.3

* Wed Nov 11 2020 joequant <joequant> 1.5.2-4.mga8
+ Revision: 1644517
- remove requires from noarch to arch repos

* Sun Oct 25 2020 joequant <joequant> 1.5.2-3.mga8
+ Revision: 1639219
- fix requires

* Thu Oct 22 2020 joequant <joequant> 1.5.2-2.mga8
+ Revision: 1638349
- fix julia requires

* Tue Oct 20 2020 joequant <joequant> 1.5.2-1.mga8
+ Revision: 1637183
- update to 1.5.2

* Sat Sep 26 2020 joequant <joequant> 1.5.1-1.mga8
+ Revision: 1630661
- update cacert
- update to 1.5.1

* Tue Aug 04 2020 joequant <joequant> 1.5.0-1.mga8
+ Revision: 1610955
- shut off debug for ix86 to avoid OOM errors
- add make.inc
- multi-thread
- remove -pipe
- add doc deps
- update to 1.5.0

* Thu Jul 23 2020 ovitters <ovitters> 1.4.2-5.mga8
+ Revision: 1608577
- fix excluded auto requires

* Thu Jul 23 2020 daviddavid <daviddavid> 1.4.2-4.mga8
+ Revision: 1608219
- filter out bogus auto-require from /usr/bin/julia

* Mon Jul 20 2020 joequant <joequant> 1.4.2-3.mga8
+ Revision: 1607440
- add requires to dSFMT

* Sun Jul 19 2020 joequant <joequant> 1.4.2-2.mga8
+ Revision: 1607253
- add pem file
- add python2 to build
- add bundled libgit2
- use bundled libgit2

* Sat Jul 18 2020 joequant <joequant> 1.4.2-1.mga8
+ Revision: 1606914
- imported package julia

